config/routes.rb
Rails.application.routes.draw do

  namespace :admin do
    resources :bookings
  end
	root to: 'home#index'
	resources :bookings
  get '/donwload_invoice', controller: 'bookings', action: 'donwload_invoice'
  get '/my-bookings', controller: 'bookings', action: 'my_bookings'
	get '/admin/reports', controller: 'admin/bookings', action: 'reports', as: :admin_reports
  # devise_for :users
  Rails.application.routes.draw do
    devise_for :users, controllers: {
      sessions: 'users/sessions'
    }
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/booking.rb
class Booking < ApplicationRecord
	belongs_to :show
	belongs_to :movie
	belongs_to :customer , :class_name => 'User'
	has_many :booked_seats

	def total_amount
		self.booked_seats.map{|booked_seat|booked_seat.seat.row.screen.price}.sum
	end
	
end

app/controllers/admin/bookings_controller.rb
class Admin::BookingsController < ApplicationController
  before_action :authenticate_user!

  def index
	 @bookings = Booking.order('created_at desc').includes(:show, :movie, :customer, {:booked_seats => {:seat => {:row => :screen}} }).paginate(page: params[:page], per_page: 5)
  end
  
  def reports
  	if params[:date].present?
  		date = params[:date].to_date
  		@bookings = Booking.where('booking_for_date = ?', date).order('created_at desc').includes(:show, :movie, :customer, {:booked_seats => {:seat => {:row => :screen}} })
  	end
  end
end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_movie, only: [:index, :create]

  def index
    if params[:step] == '2'
      @shows = @movie.shows.where(date: params[:date].to_date)
      @screens = Theatre.last.screens.order('price ASC').includes(:rows => :seats)
      get_available_seats
    else
      @shows = @movie.shows.group_by{|e|e.date}
    end
    respond_to do |format|
      format.html
      format.js
    end
  end

  def my_bookings
    @bookings = current_user.bookings.order('created_at DESC').includes(:show, :movie, :customer, {:booked_seats => {:seat => {:row => :screen}} }).paginate(page: params[:page], per_page: 5)
  end

  
  def get_available_seats
    booking_date = params[:date].to_date
    time_slot_id = params[:ts_id]
    show = @movie.shows.where(time_slot_id: params[:ts_id], date: params[:date].to_date).last
    @bookings = Booking.where(movie_id: @movie.id, booking_for_date: booking_date, show_id: show.id).includes(:movie, :booked_seats)
    @booked_seats = []
    if @bookings.present?
      @bookings.each do |booking|
        booking.booked_seats.each do |seat|
          @booked_seats << seat.seat_id
        end
      end
    end
  end

  def new

  end

  def create
    if check_valid_booking
      show = @movie.shows.where(time_slot_id: params[:time_slot_id], date: params[:booking_for_date].to_date).last
      @booking = Booking.create(
                      movie_id: @movie.id,
                      show_id: show.id,
                      booking_for_date: params[:booking_for_date].to_date,
                      customer_id: current_user.id,
                    )
      params[:seat_numbers].split(',').each do |seat_id|
        @booking.booked_seats.create(seat_id: seat_id)
      end
    else
      @cant_book = true
      @err_msg = "Sorry can't book, some of the seats just got booked. Please choose other seats."
    end  
    respond_to do |format|
      format.js
    end
  end

  def show
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
  end

  def check_valid_booking
    true #logic to check if at the same time no other customer has booked seats selected by current customer
  end

  def edit

  end

  def update

  end

  def destroy

  end

  def donwload_invoice
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
    respond_to do |format|
      format.html
      format.pdf do
       render pdf: "#{@movie.name.downcase}-invoice",
       template: "bookings/invoice.pdf.erb",
       :disposition => 'attachment',
       layout: nil
     end
    end
  end

  private

  def set_movie
    @movie = Movie.find(params[:id])
  end

end

app/helpers/admin/bookings_helper.rb
module Admin::BookingsHelper
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/views/admin/bookings/_listings.html.erb
<div class="row pt-5">
	<div class="col-md-12 white-box">
		<h3> All Bookings </h3>
		<br>
		<table class="table table-bordered">
		  <thead>
		    <tr>
		      <th scope="col">#</th>
		      <% if current_user.admin? %>
		      	<th scope="col">Customer Email</th>
		      <% end %>
		      <th scope="col">Movie Name</th>
		      <th scope="col">Booking Date</th>
		      <th scope="col">Show Timings</th>
		      <th scope="col">Seats Booked</th>
		      <% if current_user.customer? %>
		      	<th scope="col">Actions</th>
		      <% end %>
		    </tr>
		  </thead>
		  <tbody>
		    <% @bookings.each_with_index do |booking, index| %>
			    <tr>
			      <th scope="row"><%= index + 1%></th>
			      <% if current_user.admin? %>
			      	<td><%= booking.customer.email %></td>
			      <% end %>
			      <td><%= booking.movie.name.titleize %></td>
			      <td><%= booking.booking_for_date %></td>
			      <td><%= booking.show.time_slot.start_time %></td>
			      <td>
			      	<% objects = booking.booked_seats %>
              <% objects.each_with_index do |booked_seat, index| %>  
                <% seat = booked_seat.seat %>
                <% row = seat.row %>
                <% screen = row.screen %>
                <% str = '' %>
                <% str = str +  "#{screen.name}  | #{row.row_no} | #{seat.seat_no}" %> 
                <% if index > 0 and index != (objects.count + 1) %>
                  <% str = str + ', ' %>
                <% end %>
                <%= str %>
              <% end %>
			      </td>
			      <% if current_user.customer? %>
			      	<td>
			      		<% if Date.today < booking.booking_for_date.to_date %>
				      		<%= link_to root_path, class: "btn btn-danger" do %>
									  <i class="glyphicon glyphicon-remove"></i> Cancel
									<% end %>
			      		<% end %>
								<%= link_to donwload_invoice_path(id: booking.id, format: :pdf), class: "btn btn-info" do %>
								  <i class="glyphicon glyphicon-download"></i> Download Invoice
								<% end %>
			      	</td>
			      <% end %>
			    </tr>
		    <% end %>
		  </tbody>
		</table>
	</div>
</div>
<%= will_paginate @bookings %>

app/views/admin/bookings/index.html.erb
<%= render :partial => 'admin/bookings/listings' %>

app/views/admin/bookings/reports.html.erb
<div class="pt-5 white-box">
	<h3>
		Reports
	</h3>
	<hr>
	<div class="row margin-top-20px">
		<%= form_tag '/admin/reports', method: 'get' do %>
			<div class="col-md-8">
				<label for="">Select Date</label>
				<input class="special_input form-control" id="date" name="date" type="date" />
			</div>
			<div class="col-md-2" style="margin-top: 25px;">
				<%= submit_tag 'Get Report', :class => 'btn btn-primary' %>
			</div>
		<% end %>
	</div>
	
	<% if params[:date].present? %>
		<% if @bookings.present? %>
			<div class="row margin-top-20px">
				<div class="row margin-top-20px">
					<div class="col-md-12">
						<table class="table table-bordered">
						  <thead>
							<tr>
							  <th scope="col">#</th>
							  <th scope="col">Movie Name</th>
							  <th scope="col">Booking Date</th>
							  <th scope="col">Show Timings</th>
							  <th scope="col">Seats Booked</th>
							</tr>
						  </thead>
						  <tbody>
							<% @bookings.each_with_index do |booking, index| %>
								<tr>
								  <th scope="row"><%= index + 1%></th>
								  <td><%= booking.movie.name.titleize %></td>
								  <td><%= booking.booking_for_date %></td>
								  <td><%= booking.show.time_slot.start_time %></td>
								  <td>
									  <% objects = booking.booked_seats %>
							  <% objects.each_with_index do |booked_seat, index| %>  
								<% seat = booked_seat.seat %>
								<% row = seat.row %>
								<% screen = row.screen %>
								<% str = '' %>
								<% str = str +  "#{screen.name}  | #{row.row_no} | #{seat.seat_no}" %> 
								<% if index > 0 and index != (objects.count + 1) %>
								  <% str = str + ', ' %>
								<% end %>
								<%= str %>
							  <% end %>
								  </td>
								</tr>
							<% end %>
						  </tbody>
						</table>
					</div>
				</div>
			</div>
		<% else %>
			No Bookings Are Present For This Date	
		<% end %>
	<% end %>
</div>